﻿//  SearchSpecCharacters.jsx

/*
  
  Ищутся слова с переносами, такие, в которых есть символ, определённый в переменной textForSearch,
  и этот символ оказался первым символом после разделения слова при переносе.
  Проблема, ставшая поводом написания этого скрипта, переход знака ударения в церковных текстах,
  в шрифте Triodion на месте единицы сделан знак ударения. 
  Программа сперва собирает информацию о таких случаях, окрашивает все символы проблемного слова, кроме первого, цветом 'MakeupColor'.
  Цвет первого знака оставлен без изменений, чтобы востановить первоначальный цвет слова.
  Вариант исправления ситуации -- присвоить знаку ударения атрибут "Без переносов".
  Для этого надо поставить курсор в слово и щелкнуть на пиктограмме "Карандаш".
  Скрипт сам вернёт цвет этому слову.
    
*/    

//   ©   Михаил Иванюшин 2020,  dotextok.ru  |  dotextok@gmail.com


#targetengine "domakeupokN" 

var textForSearch = "1"; // в этой версии скрипта предполагается, что тут только один знак

var programTitul = "Поиск сместившихся ударений";
MakeupColorSample = [100, 0, 100, 0]; 
HelpMessage_value = false;
var ButtonSize = 189; // ширина кнопок 
var buttonInsets = 4; // это своего рода формфактор кнопок меню демонстрации результатов поиска. 
                                 // Хочется, чтобы они были квадратной формы.На машине с экраном 1366х768 эти кнопки квадратные, когда данное значение равно 4.

// идея прогресс-бара взята отсюда: http://forums.adobe.com/message/3152162#3152162
var ProgressBar = function(title) { // ProgressBar
     var w = new Window('palette', title, {x:0, y:0, width:700, height:80},{closeButton: false}),
          st = w.add('statictext', {x:20, y:12, width:660, height:20});              
          pb = w.add('progressbar', {x:20, y:32, width:660, height:12}),
          ms = w.add('statictext', {x:20, y:52, width:660, height:20});
          st.justify = 'left';
          w.center();
     this.reset = function(msg,maxValue) {
          st.text = msg;
          pb.value = 0;
          pb.maxvalue = maxValue;
          pb.visible = maxValue;
          w.show();
          w.update();
      };
     this.info = function(msg) {
          ms.text = msg;
          w.show();
     };
     this.set = function(step) {pb.value = step;  w.update();};
     this.hit = function() {++pb.value;  w.update();};
     this.close = function() {w.close();};
} // ProgressBar

////>>>> темный экран / светлый экран >>>>>
// defSelColor: цвет фона кнопки, когда в её пространстве окажется курсор. Первые три числа: RGB, 0 - мин, 1 - макс.
// defBgColor:  цвет, который приобретёт фон кнопки, когда курсор покинет её пространство.
try {
    var uiBr = app.generalPreferences.uiBrightnessPreference;
    }
catch (e) {  // до СС темного варианта интерфейса не было
    uiBr = 0.6;
    }
if (uiBr == 1 || uiBr > 0.67) { 
    defBgColor = [.85,.85,.85, 1];  defSelColor = [.15,.15,.15, 1]; 
    }
else if (uiBr == 0.67 || uiBr > 0.33) { 
    defBgColor = [.7,.7,.7, 1]; defSelColor = [.3,.3,.3, 1]; 
    }
else if (uiBr == 0.33 || uiBr > 0) { 
    defBgColor = [.34,.34,.34, 1];  defSelColor = [.66,.66,.66, 1]; 
    }
else {
    /* if (uiBr == 0) */ defBgColor = [.2,.2,.2, 1];  defSelColor = [.8,.8,.8, 1];
    }
////>>>> темный экран / светлый экран >>>>>


/////////////////
var parseIntAppVersion = parseInt (app.version);
if (parseIntAppVersion < 8) { // app.version
	alert ("Этот скрипт предназначен для работы с текстом в InDesign CS6+.", programTitul);
    exit();
    } // app.version
var mySelection = app.selection[0];
if ((mySelection == null) || (app.selection[0].length == 0)) {
    alert("Ничего не выбрано.", programTitul);	
    exit();     
    }
if(app.documents[0].stories.length == 0) {
    alert("В открытом документе нет статей.", programTitul);	
    exit();    
    }
if (textForSearch.length !=1) {
	alert ("В этой версии скрипта предполагается, что ищется только один знак. Этот искомый символ определяется в переменной 'textForSearch'.", programTitul);
    exit();    
    }
var myProblemPages = [];
var mySel;
var myStory = mySelection.parentStory;
var myInfoArray = [];   
var myContainerId = []; // тут будут собраны уникальные идентификаторы фреймов, в которых есть висячие строки
var myContainerOnPage = []; // тут будут собраны уникальные идентификаторы фреймов, по одному на каждую страницу. Этого достаточно для выбора фрейма и перехода на страницу, где этот фрейм
var myPages = [];    
while (myInfoArray.length > 0) myInfoArray.shift();
while (myContainerId.length > 0) myContainerId.shift();
while (myContainerOnPage.length > 0) myContainerOnPage.shift();
while (myPages.length > 0) myPages.shift();
while (myProblemPages.length > 0) myProblemPages.shift();
testColor(); // на случай, если будет повторный запуск выбранной ранее команды. При выборе разных команд цвет сбрасывается в процедуре SelectionAtFirst(), но тут, коль скоро нет смены кнопки, цвет удалён не будет. Поэтому надо это сделать специально.
var myScriptFile = myGetScriptPath();
var myScriptFolder = decodeURI(myScriptFile.path);

     myInfoArray = SearchSymbol();
     var myInfoArrayLength = myInfoArray.length;
     for (var j = 0; j < myInfoArrayLength; j++) { // j++
         myPages[j] = myInfoArray[j].split(",")[0];
         myContainerId[j] = myInfoArray[j].split(",")[1];
         } // j++
     ArrSize = myPages.length;
     if (ArrSize == 0) {
         alert ("В выбранном тексте строк с '" + textForSearch + "' в начале строки не найдено." ,programTitul);        
         exit();
         }     
     ProblemPagesAndContainers();
     var SearchOneWord = "Результаты поиска строк с '" + textForSearch + "' в начале строки ";
     myShowPage(SearchOneWord); 
     
////////////////
function SearchSymbol() { //SearchSymbol
    var myStory = app.selection[0];
    var InfoLine = "";
    var myPages = [];
    while (myPages.length > 0) myPages.shift();
    TestFramesOnPasteboard();
	var pBar = new ProgressBar(programTitul);    
    var nmbrOfLines = myStory.lines.length;
	pBar.reset(" Поиск символа " + textForSearch , nmbrOfLines);     
    pBar.info("");
    for (var i = 0; i <  nmbrOfLines-1; i++, pBar.hit()) { // nmbrOfLines	
           try { lineLength = myStory.lines[i].length; } catch (e) { continue }
           try { lineLength = myStory.lines[i+1].length; } catch (e) { continue }           
            var myLine1=myStory.lines[i];
            var w1 = myLine1.words[-1];
            var myLine2=myStory.lines[i+1];
            var w2 = myLine2.words[0];
            try { w1i = w1.index; w2i = w2.index; } catch (e) { continue; }
            if (w1.index == w2.index) { // слово переносится

                if (myLine2.characters[0].contents == textForSearch) { // textForSearch
                     wL = w1.length;
                     w1.characters.itemByRange(1,wL-1).fillColor = "MakeupColor"; // первый символ сохранил исходный цвет, остальные стали цвета MakeupColor
                     InfoLine = "," + myLine2.parentTextFrames[0].id;
                     myPages.push (myLine2.parentTextFrames[0].parentPage.name + InfoLine);
                     continue;                     
                    } // textForSearch
                } // слово переносится    
	} // nmbrOfLines     
return myPages;
} // SearchSymbol  ////////////////////////
///////////////
    function myShowPage(NameOfAction) { // myShowPage
    var ShowPage = new Window ("palette", programTitul, undefined, {closeButton: true}); 
    ShowPage.alignChildren = ["fill", "fill"];
    var myBtnUp = File (decodeURI(myScriptFolder + "/Picts/" + "ArrowUp-16.png"));
    var myBtnDn = File (decodeURI(myScriptFolder + "/Picts/" + "ArrowDn-16.png"));
    var myBtnDel = File (decodeURI(myScriptFolder + "/Picts/" + "DelBtn.png"));    
    var ShowTools = ShowPage.add("group");
    ShowTools.orientation = "row";
    ShowTools.alignChildren = ["fill", "fill"]; 
    var myProblemPagesLength = myProblemPages.length;
    var StartInd = 1;
    InfoFieldLine = StartInd +"/" + myProblemPagesLength;    
    var InfoPanel = ShowTools.add("panel");
    var InfoField =  InfoPanel.add("statictext", undefined, InfoFieldLine);   
    InfoField.characters = 10;   
    
const pencil = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x1D\x00\x00\x00\x1D\b\x06\x00\x00\x00V\u0093g\x0F\x00\x00\x00\tpHYs\x00\x00\x0B\x12\x00\x00\x0B\x12\x01\u00D2\u00DD~\u00FC\x00\x00\x017IDATH\u00C7c\u00F8\u00FF\u00FF?\x03\u00BD1\u00C3\u00A8\u00A5\u00A3\u0096\x124\u0090\u00E1\u00BF\x02\x10_\x00\u00E2\x03@l@sK\u0081\u00A6\x05\x00\u00F1\x03(\u009D\x00\u00C4\x1F\u0080X\u0080f\u0096\x02M\u009A\x00\u00F5\u00A1\x02\u009AX\x01\u00D5-E\n\u00CE\u00FFP\x1C\u0080$\u00D7\x00\u00C4\x1B\u00A8j)P\u00B7\x0348\x0F Y\u00FA\x01\u00EA\u0090\rPq\u00EA\x05/\u00D4\x17\x17\u0090\u00E8\x0Bh\x167P-\u00F5\u0082\\\x0E\u00F5\u00C1\x06$<\x01\u00C9R\u0090\u0085\x0ET\u00CB2H\u00C1\t\u00B3d\x02\u00D4\x01\x0B\u00A0\u00F8\x02\u00B6\u00E0$\u00DBRP*D\n\u00CE\x07h|\u00B0\x03\u00A8V8@\u0083s\x03\u0092o\x0E\u00A0\u00C5\u00E7\x03\u00E4\x14K\u00B1\u00A5\u00A0\x12\x05\u00CD7\x0B\u00D0\x1C\u0080\u0092/)\u00B6\x14\x1A\x7F\x1F\u00A0>y\u0080\u00E6\u00BB\x03\u00A4\x04'Q\u0096ndX%o\u00C3\u00F0\u00E52\u00D4\u00A7\x0B\u00A0\u0096^\u0080\u00C6#\u0088\u009D@\u00F5\x02\u00FF\x02C\u00CB\u00F9\u00DF\f\u00CA\u00DF\u0081\u00D2\x06H\x19\u00FD\x03\u00D4b\x03\u00AA\u00D72\u00BB\x19\u00E6\x17\u00C0r\u00F8?\x06\u00C1G\u00D0\u0082\x1B\x16\u009F\x024\u00A9\u00DA>0x\u00FC\u0084Y\u00FA\u0092!\u00EA\x1B4/\x1A\u00D0\u00AC>=\u00C3\u00D0}\u00E06C\u00F1\u00F3\u00E3\f\x13\u00D7oaXn3\u00DAr\x18\u00B5t\u00D4\u00D2Aa)\x00H\b\x1C\u00FEQ{n\u00A7\x00\x00\x00\x00IEND\u00AEB`\u0082"
var myAction = makeImageButton (pencil, true, buttonInsets, ShowTools, myActionOnClick);    
    
    if (!HelpMessage_value) myAction.helpTip = "Присвоение символу '" + textForSearch + "' атрибута 'Без переносов'. В результате слово будет целиком на строке.";
    else myUpButton.helpTip = "";    
    var myUpButton = makeImageButton (myBtnUp, true, buttonInsets, ShowTools, myUpButtonOnClick);
    if (!HelpMessage_value) myUpButton.helpTip = "Перемещение на предыдущую страницу";
    else myUpButton.helpTip = "";

     var myDnButton = makeImageButton (myBtnDn, true, buttonInsets, ShowTools, myDnButtonOnClick);   
     if (!HelpMessage_value) myDnButton.helpTip = "Перемещение на следующую страницу";
     else myDnButton.helpTip = "";

    var myDelButton = makeImageButton (myBtnDel, true, buttonInsets, ShowTools, myDelButtonOnClick);       
    if (!HelpMessage_value) myDelButton.helpTip = "Завершение просмотра";
    else myDelButton.helpTip = "";

    app.documents[0].pageItems.itemByID(Number(myContainerOnPage[0])).select();    
    app.activeWindow.activePage = app.selection[0].parentPage;    
    app.documents[0].layoutWindows[0].zoom(ZoomOptions.FIT_SPREAD);
    app.documents[0].select(NothingEnum.nothing);
    
    function myActionOnClick() { // myAction.onClick
        var mS = app.selection[0];
        if ((mS == null) || (mS.words.length != 1) || (mS.words[0].characters[mS.words[0].length-1].fillColor.name != "MakeupColor")) {
            alert("Поставьте курсор в слово, отмеченное цветом 'MakeupColor'.");
            return;
            }
        app.selection[0].words[0].select();
        mS = app.selection[0];
        app.findGrepPreferences = NothingEnum.nothing;
        app.changeGrepPreferences = NothingEnum.nothing;
        app.findGrepPreferences.findWhat = textForSearch; // ищем символ потерянной сноски 
        fCh = mS.findGrep();
        if (fCh.length == 0) {
            alert("Символ " + textForSearch + " не найден.");
            return;
            }
        fCh[0].noBreak = true; // запрет переноса для знака
        usedClr = mS.words[0].characters[0].fillColor.name; // первая буква сохранила исходный цвет слова...
        mS.words[0].fillColor = usedClr; // ... восстановим его
        } //  myAction.onClick
    
    function myDelButtonOnClick () { //  myDelButton.onClick       
        ShowPage.close(); 
        try { app.documents[0].colors.item("MakeupColor").remove(); } catch (e) { } // цвета удаляются, чтобы снять выделение цветом
        app.findGrepPreferences = NothingEnum.nothing;
        app.changeGrepPreferences = NothingEnum.nothing;        
        exit();
        } //  myDelButton.onClick
    ///////
    function myDnButtonOnClick () { //  myDnButton.onClick        
        StartInd++;
        if (StartInd > myProblemPagesLength) { // StartInd > myProblemPagesLength
            for (var ii = 0; ii < 3; ii++) { // ii++ 
                InfoFieldLine =  "<<#>>";
                InfoField.text = InfoFieldLine;   
                ShowPage.update();                
                $.sleep(300);   // 300 ms timer
                InfoFieldLine =   "######";
                InfoField.text = InfoFieldLine;       
                ShowPage.update();               
                $.sleep(300);   // 300 ms timer           
                } // i++
            StartInd = 1;
            } // StartInd > myProblemPagesLength
        InfoFieldLine = StartInd +"/" + myProblemPagesLength;        
        InfoField.text = InfoFieldLine;
        app.documents[0].pageItems.itemByID(Number(myContainerOnPage[StartInd-1])).select();    
        app.activeWindow.activePage = app.selection[0].parentPage;    
        app.documents[0].layoutWindows[0].zoom(ZoomOptions.FIT_SPREAD);
        app.documents[0].select(NothingEnum.nothing);        
        }  //  myDnButton.onClick
    //////
    function myUpButtonOnClick () { //  myUpButton.onClick      
        StartInd--;
        if (StartInd == 0) { // StartInd == 0
            for (var ii = 0; ii < 3; ii++) { // ii++ 
                InfoFieldLine =  "<<#>>";
                InfoField.text = InfoFieldLine;   
                ShowPage.update();
                $.sleep(300);   // 300 ms timer
                InfoFieldLine =   "######";
                InfoField.text = InfoFieldLine;  
                ShowPage.update();                
                $.sleep(300);   // 300 ms timer     
                } // i++          
            StartInd = myProblemPagesLength;
            } // StartInd == 0
        InfoFieldLine = StartInd +"/" + myProblemPagesLength;        
        InfoField.text = InfoFieldLine;
        app.documents[0].pageItems.itemByID(Number(myContainerOnPage[StartInd-1])).select();    
        app.activeWindow.activePage = app.selection[0].parentPage;    
        app.documents[0].layoutWindows[0].zoom(ZoomOptions.FIT_SPREAD);
        app.documents[0].select(NothingEnum.nothing);        
        }  //  myUpButton.onClick
    //////
    ShowPage.show();
   }  // myShowPage
/////
function TestFramesOnPasteboard() { // TestFramesOnPasteboard() 
	 //цикл по числу колонок статьи. Цикл начинается со второй колонки
     var myPageStrart = -1;
	var pBar = new ProgressBar(programTitul);
	pBar.reset(" Поиск фреймов на рабочем столе в выбранной текстовой цепочке. Их быть не должно" , myStory.textColumns.length);
	 for (var i = 0; i < myStory.textColumns.length; i ++, pBar.hit()) { // поиск фреймов на рабочем столе    
         try { 
             myPageStrart = myStory.textColumns[i].parentTextFrames[0].parentPage.name; 
             }
         catch (e) { 
             pBar.close(); 
             if (myPageStrart != -1) alert ("Встречен фрейм на рабочем столе.\nПоследняя страница текстовой цепочки, на которой фрейм размещён на полосе — " + myPageStrart + "." ,programTitul);
             else alert ("Первый же фрейм выбранной текстовой цепочки лежит на рабочем столе." ,programTitul);
             exit(); 
             }
         } // поиск фреймов на рабочем столе
     } // TestFramesOnPasteboard()
/////////
function testColor() { // testColor
try { app.documents[0].colors.item("MakeupColor").remove(); } catch (e) { } // цвета удаляются, чтобы снять выделение цветом
//try { app.documents[0].swatches.item("MakeupColor").remove(); } catch (e) { }  
try{
    MakeupColor = app.documents[0].colors.item("MakeupColor").name;
    }
catch (e) {
    MakeupColor = app.documents[0].colors.add ({name:"MakeupColor", model:ColorModel.process, space:ColorSpace.CMYK, colorValue:MakeupColorSample});
    }
} // testColor
//////////
function myFile(myFileName) {
var myScriptFile = myGetScriptPath();
var myScriptFolder = decodeURI(myScriptFile.path);
var myFilePath = decodeURI(myScriptFolder + "/" +myFileName);
return myFilePath;
} //myFile
//
function myGetScriptPath() {
	try{
		return app.activeScript;
	}
	catch(myError){
		return File(myError.fileName);
	}
} //myGetScriptPath()
///////////////////
function makeImageButton (myPngButton, buttonBorder, buttonInset, winLink, imageButtonAction) { // makeImageButton

// InDesign CC Flag
const CC_FLAG = +(9 <= parseFloat(app.version));
///
// ScriptUI Image Offset Fixer in InDesign CS6 and earlier
// (This bug has been solved in CC i.e. ScriptUI 6.2.x)
const FIX_OFFSET = CC_FLAG ? 0 : 1;
///
// Force an Image widget to repaint (= onDraw trigger)
// CS4-CS6  ->  just reassigning this.size
// CC             ->  we need to temporarily *change* the size
// Note: using layout.layout(1) would not work anymore in CC
// ---
// Create the UI
if (buttonBorder) var winImageButton = winLink.add("panel");
else var winImageButton = winLink.add("group");
imageButton = winImageButton.add('image', undefined, myPngButton);
imageSize = imageButton.image.size;
Image.prototype.refresh = CC_FLAG ?
	function() {
		var wh = this.size;
		this.size = [1+wh[0], 1+wh[1]];
		this.size = [wh[0], wh[1]];
		wh = null;
	}:
	function() { this.size = [this.size[0],this.size[1]]; };
// Window settings
winImageButton.margins = buttonInset;
winImageButton.alignChildren = ['center','center'];
imageButton.size = [imageSize[0], imageSize[1]];
imageButton.onDraw = function() {
     var dy = 0 + FIX_OFFSET;
	this.graphics.drawImage(this.image, 0,-dy);
    // winLink.graphics.backgroundColor = winLink.graphics.newBrush(0, [.92,.94,.96,1]);
    };
var mouseEventHandler = function(ev) { // mouseEventHandler
	if (ev.type == 'mouseover' )  winImageButton.graphics.backgroundColor = winImageButton.graphics.newBrush(0, defSelColor);
    //else winImageButton.graphics.backgroundColor = winImageButton.graphics.newBrush(0, [.92,.94,.96,1]); 
    else winImageButton.graphics.backgroundColor = winImageButton.graphics.newBrush(0, defBgColor);      
	this.refresh();
    } // mouseEventHandler
///
imageButton.addEventListener('mouseover', mouseEventHandler);
imageButton.addEventListener('mousedown', mouseEventHandler);
imageButton.addEventListener('mouseup', mouseEventHandler);
imageButton.addEventListener('mouseout', mouseEventHandler);
// Let's go!
imageButton.addEventListener('click', function() { imageButtonAction() } );
///
return imageButton;
} // makeImageButton
//////////////////////////////////////
function ProblemPagesAndContainers() { // ProblemPagesAndContainers
    NmbrOfRepeat = -1;
    ArrSize = myPages.length;
    for (var i = 0, j = 0; i < ArrSize; i++) { // ArrSize > 0
        /*
            Следующая процедура учитывает случаи, когда на одной странице встречается несколько случаев наличия висячих строк. Например, многоколонники, или отдельные фреймы.
            Предположим, поиск висячих строк вернул такой массив myPages : 1, 1, 1, 2
            Т.е. на первой странице есть три висячих строки, и одна на второй странице.
            В результате обработки в массиве myProblemPages будет такая информация: 1, 2
            В массиве myContainerOnPage будут идентификаторы фреймов, размещенных на каждой из страниц, указанных в массиве myProblemPages
            */
        if (NmbrOfRepeat == -1) { // == -1
            myProblemPages[j] = myPages[i];   
            myContainerOnPage[j] = myContainerId[i];
            NmbrOfRepeat++;
            continue;
            } // == -1
        if (NmbrOfRepeat == 0) { // == 0
            if (myPages[i] == myProblemPages[j]) { // i == j
                NmbrOfRepeat++;               
                continue;
                }  // i-- == j
            else { // j++
                j++;
                myProblemPages[j] = myPages[i]; 
                myContainerOnPage[j] = myContainerId[i];                             
                continue;
                } // j++
            } // == 0
        if (NmbrOfRepeat > 0) { // > 0
            if (myPages[i] == myProblemPages[j]) { // [i] == [j]
                NmbrOfRepeat++;           
                continue;
                }  // [i--] == [j]
            else { // else
                NmbrOfRepeat++; // до этого момента эта переменная хранила число совпадений. Но надо учесть и первое одинаковое значение         
                j++;
                myProblemPages[j] = myPages[i];
                myContainerOnPage[j] = myContainerId[i];                  
                NmbrOfRepeat = 0;
                } // else
            } // > 0
        } // ArrSize > 0
    } // ProblemPagesAndContainers

